## r8168 8.028.00

=== Makefile ===
################################################################################
# 
# r8168 is the Linux device driver released for RealTek RTL8168B/8111B, 
# RTL8168C/8111C, RTL8168CP/8111CP, RTL8168D/8111D, and RTL8168DP/8111DP
# Gigabit Ethernet controllers with PCI-Express interface.
# 
# Copyright(c) 2011 Realtek Semiconductor Corp. All rights reserved.
# 
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
# 
# You should have received a copy of the GNU General Public License along with
# this program; if not, see <http://www.gnu.org/licenses/>.
# 
# Author:
# Realtek NIC software team <nicfae@realtek.com>
# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
# 
################################################################################

################################################################################
# This product is covered by one or more of the following patents:
# US5,307,459, US5,434,872, US5,732,094, US6,570,884, US6,115,776, and US6,327,625.
################################################################################

KFLAG := 2$(shell uname -r | sed -ne 's/^2\.[4]\..*/4/p')x

all: clean modules install

modules:
ifeq ($(KFLAG),24x)
	$(MAKE) -C src/ -f Makefile_linux24x modules
else
	$(MAKE) -C src/ modules
endif

clean:
ifeq ($(KFLAG),24x)
	$(MAKE) -C src/ -f Makefile_linux24x clean
else
	$(MAKE) -C src/ clean
endif

install:
ifeq ($(KFLAG),24x)
	$(MAKE) -C src/ -f Makefile_linux24x install
else
	$(MAKE) -C src/ install
endif

=== src/Makefile ===
################################################################################
# 
# r8168 is the Linux device driver released for RealTek RTL8168B/8111B, 
# RTL8168C/8111C, RTL8168CP/8111CP, RTL8168D/8111D, and RTL8168DP/8111DP, and
# RTL8168E/8111E Gigabit Ethernet controllers with PCI-Express interface.
# 
# Copyright(c) 2011 Realtek Semiconductor Corp. All rights reserved.
# 
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
# 
# You should have received a copy of the GNU General Public License along with
# this program; if not, see <http://www.gnu.org/licenses/>.
# 
# Author:
# Realtek NIC software team <nicfae@realtek.com>
# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
# 
################################################################################

################################################################################
# This product is covered by one or more of the following patents:
# US5,307,459, US5,434,872, US5,732,094, US6,570,884, US6,115,776, and US6,327,625.
################################################################################

CONFIG_DOWN_SPEED_100 = n

ifneq ($(KERNELRELEASE),)
	obj-m := r8168.o
	r8168-objs := r8168_n.o r8168_asf.o rtl_eeprom.o rtltool.o
	EXTRA_CFLAGS += -DCONFIG_R8168_NAPI
	EXTRA_CFLAGS += -DCONFIG_R8168_VLAN
	ifeq ($(CONFIG_DOWN_SPEED_100), y)
		EXTRA_CFLAGS += -DCONFIG_DOWN_SPEED_100 
	endif
else
	BASEDIR := /lib/modules/$(shell uname -r)
	KERNELDIR ?= $(BASEDIR)/build
	PWD :=$(shell pwd)
	DRIVERDIR := $(shell find $(BASEDIR)/kernel/drivers/net -name realtek -type d)
	ifeq ($(DRIVERDIR),)
		DRIVERDIR := $(BASEDIR)/kernel/drivers/net
	endif
	RTKDIR := $(subst $(BASEDIR)/,,$(DRIVERDIR))

.PHONY: all
all: clean modules install

.PHONY:modules
modules:
	$(MAKE) -C $(KERNELDIR) SUBDIRS=$(PWD) modules

.PHONY:clean
clean:
	$(MAKE) -C $(KERNELDIR) SUBDIRS=$(PWD) clean

.PHONY:install
install:
	$(MAKE) -C $(KERNELDIR) SUBDIRS=$(PWD) INSTALL_MOD_DIR=$(RTKDIR) modules_install

endif

## r8168 8.026.00

=== debian/changelog ===
r8168 (8.026.00-1) unstable; urgency=low

  * Initial release.  (Closes: #642198, #648286)

 -- Andreas Beckmann <debian@abeckmann.de>  Wed, 16 Nov 2011 13:50:53 +0100

=== debian/control ===
Source: r8168
Section: kernel
Priority: extra
Maintainer: Andreas Beckmann <debian@abeckmann.de>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 8), dkms
Standards-Version: 3.9.2
Homepage: http://code.google.com/p/r8168/
Vcs-Git: git://github.com/anbe42/r8168.git
Vcs-Browser: https://github.com/anbe42/r8168

Package: r8168-dkms
Architecture: all
Depends: ${misc:Depends}
Description: dkms source for the r8168 network driver
 r8168 is the Linux device driver released for RealTek RTL8168B/8111B,
 RTL8168C/8111C, RTL8168CP/8111CP, RTL8168D/8111D, and RTL8168DP/8111DP, and
 RTK8168E/8111E Gigabit Ethernet controllers with PCI-Express interface.
 .
 This driver should only be used for devices not yet supported by the
 in-kernel driver r8169. Please see the README.Debian for instructions how
 to report bugs against r8169 that made it necessary to use r8168-dkms.
 .
 Installation of the r8168-dkms package will disable the in-kernel r8169
 module. To re-enable r8169, the r8168-dkms package must be purged.
 .
 This package provides the dkms source code for the r8168 kernel modules.
 Kernel source or headers are required to compile these modules.

=== debian/rules ===
#!/usr/bin/make -f

VERSION	:= $(shell dpkg-parsechangelog | sed -nr '/^Version:/s/Version: (.*:)?(.*)-(.*)/\2/p')

%:
	dh $@ --with dkms

override_dh_install:
	dh_install src/*.h src/*.c src/Makefile usr/src/r8168-$(VERSION)/

override_dh_dkms:
	dh_dkms -V $(VERSION)

# do nothing
override_dh_auto_configure override_dh_auto_build override_dh_auto_test override_dh_auto_install override_dh_auto_clean:

=== debian/watch ===
version=3

# The upstream download page at
# http://www.realtek.com/downloads/downloadsView.aspx?Langid=1&PNid=13&PFid=5&Level=5&Conn=4&DownTypeID=3&GetDown=false#2
# uses javascript to actually generate the download URL which finally
# redirects to a dynamically created ftp account like
# ftp://user:password@ip.ip.ip.ip/path/to/r8168-(.*).tar.bz2

# But there exists an unofficial mirror at http://code.google.com/p/r8168/
http://googlecode.debian.net/p/r8168/r8168-(\d+.*)\.tar\.bz2

## r8168 8.027.00

=== debian/changelog ===
r8168 (8.027.00-2) unstable; urgency=low

  [ Julien Valroff ]
  * Add patch to fix build with Linux kernel >= 3.2.  (Closes: #656734)

  [ Andreas Beckmann ]
  * Do not break build with Linux kernel < 3.2 while fixing >= 3.2.

 -- Andreas Beckmann <debian@abeckmann.de>  Sun, 29 Jan 2012 16:33:48 +0100

r8168 (8.027.00-1) unstable; urgency=low

  * New upstream release 8.027.00 (2011-12-01).
  * Move git repository to git://git.debian.org/git/collab-maint/r8168.git
  * Add Dmitry Smirnov to Uploaders.
  * Work around dkms bug #651973 by adding BUILT_MODULE_NAME to dkms.conf.
  * Remove executable permission from module source code.

 -- Andreas Beckmann <debian@abeckmann.de>  Wed, 14 Dec 2011 18:13:15 +0100

## r8168 8.028.00

=== debian/changelog ===
r8168 (8.028.00-1) unstable; urgency=low

  * New upstream release 8.028.00 (2012-02-03).
  * Drop 001_build-with-kernel-3.2.x.diff, fixed upstream.

 -- Andreas Beckmann <debian@abeckmann.de>  Fri, 17 Feb 2012 11:31:30 +0100

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,13 @@
 Section: kernel
 Priority: extra
 Maintainer: Andreas Beckmann <debian@abeckmann.de>
+Uploaders: Dmitry Smirnov <onlyjob@member.fsf.org>
 DM-Upload-Allowed: yes
 Build-Depends: debhelper (>= 8), dkms
 Standards-Version: 3.9.2
 Homepage: http://code.google.com/p/r8168/
-Vcs-Git: git://github.com/anbe42/r8168.git
-Vcs-Browser: https://github.com/anbe42/r8168
+Vcs-Git: git://git.debian.org/git/collab-maint/r8168.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/r8168.git
 
 Package: r8168-dkms
 Architecture: all

## r8168 8.031.00

=== Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 # RTL8168C/8111C, RTL8168CP/8111CP, RTL8168D/8111D, and RTL8168DP/8111DP
 # Gigabit Ethernet controllers with PCI-Express interface.
 # 
-# Copyright(c) 2011 Realtek Semiconductor Corp. All rights reserved.
+# Copyright(c) 2012 Realtek Semiconductor Corp. All rights reserved.
 # 
 # This program is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by the Free

=== src/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 # RTL8168C/8111C, RTL8168CP/8111CP, RTL8168D/8111D, and RTL8168DP/8111DP, and
 # RTL8168E/8111E Gigabit Ethernet controllers with PCI-Express interface.
 # 
-# Copyright(c) 2011 Realtek Semiconductor Corp. All rights reserved.
+# Copyright(c) 2012 Realtek Semiconductor Corp. All rights reserved.
 # 
 # This program is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by the Free

=== debian/changelog ===
r8168 (8.031.00-1) unstable; urgency=low

  * New upstream release 8.031.00 (2012-05-28).

 -- Andreas Beckmann <debian@abeckmann.de>  Fri, 08 Jun 2012 06:47:43 +0200

r8168 (8.030.00-1) unstable; urgency=low

  * New upstream release 8.030.00 (2012-05-14).
  * Add update-initramfs hook to install the r8168 module in the initrd.
    (Closes: #669052)

 -- Andreas Beckmann <debian@abeckmann.de>  Wed, 23 May 2012 02:08:12 +0200

r8168 (8.029.00-1) unstable; urgency=low

  [ Dmitry Smirnov ]
  * d-watch: fetch directly from code.google.com

  [ Andreas Beckmann ]
  * New upstream release 8.029.00 (2012-03-29).
  * debian/copyright: Use final copyright-format 1.0 URL and bump years.
  * Bump Standards-Version to 3.9.3 (no changes needed).

 -- Andreas Beckmann <debian@abeckmann.de>  Wed, 04 Apr 2012 10:50:07 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Dmitry Smirnov <onlyjob@member.fsf.org>
 DM-Upload-Allowed: yes
 Build-Depends: debhelper (>= 8), dkms
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://code.google.com/p/r8168/
 Vcs-Git: git://git.debian.org/git/collab-maint/r8168.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/r8168.git

## r8168 8.035.00

=== src/Makefile ===
--- 
+++ 
@@ -31,6 +31,7 @@
 ################################################################################
 
 CONFIG_DOWN_SPEED_100 = n
+CONFIG_ASPM = y
 
 ifneq ($(KERNELRELEASE),)
 	obj-m := r8168.o
@@ -39,6 +40,9 @@
 	EXTRA_CFLAGS += -DCONFIG_R8168_VLAN
 	ifeq ($(CONFIG_DOWN_SPEED_100), y)
 		EXTRA_CFLAGS += -DCONFIG_DOWN_SPEED_100 
+	endif
+	ifeq ($(CONFIG_ASPM), y)
+		EXTRA_CFLAGS += -DCONFIG_ASPM 
 	endif
 else
 	BASEDIR := /lib/modules/$(shell uname -r)

=== debian/changelog ===
r8168 (8.035.00-1ubuntu1) raring; urgency=low

  * kernel-3.8.patch: New, fix building the module for kernel 3.8
    that removed the __dev* attributes.  (LP: #1108068, #1156283)

 -- Adam Conrad <adconrad@ubuntu.com>  Sat, 11 May 2013 02:43:22 -0600

r8168 (8.035.00-1) unstable; urgency=low

  * New upstream release 8.035.00 (2012-12-21).
  * Update my email address and drop DMUA.
  * Switch to Standards-Version: 3.9.4 (no changes needed).

 -- Andreas Beckmann <anbe@debian.org>  Fri, 25 Jan 2013 19:55:16 +0100

r8168 (8.034.00-1) unstable; urgency=low

  * New upstream release 8.034.00 (2012-11-02).

 -- Andreas Beckmann <debian@abeckmann.de>  Fri, 23 Nov 2012 20:56:53 +0100

r8168 (8.032.00-1) unstable; urgency=low

  * New upstream release 8.032.00 (2012-08-01).

 -- Andreas Beckmann <debian@abeckmann.de>  Wed, 12 Sep 2012 13:32:29 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,11 @@
 Source: r8168
 Section: kernel
 Priority: extra
-Maintainer: Andreas Beckmann <debian@abeckmann.de>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Andreas Beckmann <anbe@debian.org>
 Uploaders: Dmitry Smirnov <onlyjob@member.fsf.org>
-DM-Upload-Allowed: yes
 Build-Depends: debhelper (>= 8), dkms
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Homepage: http://code.google.com/p/r8168/
 Vcs-Git: git://git.debian.org/git/collab-maint/r8168.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/r8168.git

## r8168 8.036.00

=== debian/changelog ===
r8168 (8.036.00-2) unstable; urgency=low

  * kernel-3.10.patch: New, fix building the module for kernel 3.10.
    (Closes: #717161)

 -- Andreas Beckmann <anbe@debian.org>  Sun, 21 Jul 2013 20:44:48 +0200

r8168 (8.036.00-1) unstable; urgency=low

  * New upstream release 8.036.00 (2013-06-17).
  * kernel-3.8.patch: Remove, fixed upstream.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 02 Jul 2013 10:50:38 +0200

r8168 (8.035.00-2) unstable; urgency=low

  * kernel-3.8.patch: New, fix building the module for kernel 3.8+ that has
    removed the __dev* attributes.  (Closes: #706978) (LP: #1108068, #1156283)
  * Use canonical Vcs-* URLs.
  * Switch to debhelper 9.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 07 May 2013 10:02:12 +0200

## r8168 8.037.00

=== src/Makefile ===
--- 
+++ 
@@ -1,37 +1,37 @@
 ################################################################################
-# 
-# r8168 is the Linux device driver released for RealTek RTL8168B/8111B, 
-# RTL8168C/8111C, RTL8168CP/8111CP, RTL8168D/8111D, and RTL8168DP/8111DP, and
-# RTL8168E/8111E Gigabit Ethernet controllers with PCI-Express interface.
-# 
-# Copyright(c) 2012 Realtek Semiconductor Corp. All rights reserved.
-# 
+#
+# r8168 is the Linux device driver released for Realtek Gigabit Ethernet
+# controllers with PCI-Express interface.
+#
+# Copyright(c) 2013 Realtek Semiconductor Corp. All rights reserved.
+#
 # This program is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by the Free
 # Software Foundation; either version 2 of the License, or (at your option)
 # any later version.
-# 
+#
 # This program is distributed in the hope that it will be useful, but WITHOUT
 # ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 # FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 # more details.
-# 
+#
 # You should have received a copy of the GNU General Public License along with
 # this program; if not, see <http://www.gnu.org/licenses/>.
-# 
+#
 # Author:
 # Realtek NIC software team <nicfae@realtek.com>
 # No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
-# 
+#
 ################################################################################
 
 ################################################################################
-# This product is covered by one or more of the following patents:
-# US5,307,459, US5,434,872, US5,732,094, US6,570,884, US6,115,776, and US6,327,625.
+#  This product is covered by one or more of the following patents:
+#  US6,570,884, US6,115,776, and US6,327,625.
 ################################################################################
 
 CONFIG_DOWN_SPEED_100 = n
 CONFIG_ASPM = y
+ENABLE_S5WOL = y
 
 ifneq ($(KERNELRELEASE),)
 	obj-m := r8168.o
@@ -43,6 +43,9 @@
 	endif
 	ifeq ($(CONFIG_ASPM), y)
 		EXTRA_CFLAGS += -DCONFIG_ASPM 
+	endif
+	ifeq ($(ENABLE_S5WOL), y)
+		EXTRA_CFLAGS += -DENABLE_S5WOL 
 	endif
 else
 	BASEDIR := /lib/modules/$(shell uname -r)

=== debian/changelog ===
r8168 (8.037.00-1) unstable; urgency=low

  * New upstream release 8.037.00 (2013-09-24).
  * kernel-3.10.patch: Remove, fixed upstream.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 16 Oct 2013 23:53:46 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: r8168
 Section: kernel
 Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Andreas Beckmann <anbe@debian.org>
+Maintainer: Andreas Beckmann <anbe@debian.org>
 Uploaders: Dmitry Smirnov <onlyjob@member.fsf.org>
-Build-Depends: debhelper (>= 8), dkms
+Build-Depends: debhelper (>= 9), dkms
 Standards-Version: 3.9.4
 Homepage: http://code.google.com/p/r8168/
-Vcs-Git: git://git.debian.org/git/collab-maint/r8168.git
+Vcs-Git: git://anonscm.debian.org/collab-maint/r8168.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/r8168.git
 
 Package: r8168-dkms

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+#export DH_VERBOSE=1
 
 VERSION	:= $(shell dpkg-parsechangelog | sed -nr '/^Version:/s/Version: (.*:)?(.*)-(.*)/\2/p')
 
@@ -7,6 +9,7 @@
 
 override_dh_install:
 	dh_install src/*.h src/*.c src/Makefile usr/src/r8168-$(VERSION)/
+	find debian/r8168-dkms/usr/src -type f -perm -5 -print0 2>/dev/null | xargs -0r chmod a-X
 
 override_dh_dkms:
 	dh_dkms -V $(VERSION)

=== debian/watch ===
--- 
+++ 
@@ -7,4 +7,4 @@
 # ftp://user:password@ip.ip.ip.ip/path/to/r8168-(.*).tar.bz2
 
 # But there exists an unofficial mirror at http://code.google.com/p/r8168/
-http://googlecode.debian.net/p/r8168/r8168-(\d+.*)\.tar\.bz2
+http://code.google.com/p/r8168/downloads/list?can=1 .*/r8168-([\d\.]+)\.(?:tar\.gz|tar\.bz2|tar\.xz)

## r8168 8.038.00

=== src/Makefile ===
--- 
+++ 
@@ -29,6 +29,7 @@
 #  US6,570,884, US6,115,776, and US6,327,625.
 ################################################################################
 
+ENABLE_DASH_SUPPORT = n
 CONFIG_DOWN_SPEED_100 = n
 CONFIG_ASPM = y
 ENABLE_S5WOL = y
@@ -36,6 +37,10 @@
 ifneq ($(KERNELRELEASE),)
 	obj-m := r8168.o
 	r8168-objs := r8168_n.o r8168_asf.o rtl_eeprom.o rtltool.o
+	ifeq ($(ENABLE_DASH_SUPPORT), y)
+	    r8168-objs += r8168_dash.o
+		EXTRA_CFLAGS += -DENABLE_DASH_SUPPORT
+	endif
 	EXTRA_CFLAGS += -DCONFIG_R8168_NAPI
 	EXTRA_CFLAGS += -DCONFIG_R8168_VLAN
 	ifeq ($(CONFIG_DOWN_SPEED_100), y)

=== debian/changelog ===
r8168 (8.038.00-1) unstable; urgency=medium

  * New upstream release 8.038.00 (2014-03-04).
  * Update watch file.
  * Bump Standards-Version to 3.9.5 (no changes needed).
  * Use module aliases for PCI IDs supported by r8168 instead of blacklisting
    r8169.  (Closes: #739394)
  * Update model list in package description.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 21 Apr 2014 22:16:01 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Andreas Beckmann <anbe@debian.org>
 Uploaders: Dmitry Smirnov <onlyjob@member.fsf.org>
 Build-Depends: debhelper (>= 9), dkms
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: http://code.google.com/p/r8168/
 Vcs-Git: git://anonscm.debian.org/collab-maint/r8168.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/r8168.git
@@ -13,9 +13,10 @@
 Architecture: all
 Depends: ${misc:Depends}
 Description: dkms source for the r8168 network driver
- r8168 is the Linux device driver released for RealTek RTL8168B/8111B,
- RTL8168C/8111C, RTL8168CP/8111CP, RTL8168D/8111D, and RTL8168DP/8111DP, and
- RTK8168E/8111E Gigabit Ethernet controllers with PCI-Express interface.
+ r8168 is the Linux device driver released for RealTek RTL8111B/RTL8168B,
+ RTL8111/RTL8168, RTL8111C/RTL8111CP/RTL8111D(L), RTL8168C/RTL8111DP/RTL8111E,
+ RTL8168E/RTL8111F/RTL8411, RTL8111G/RTL8111GUS/RTL8411B(N)
+ Gigabit Ethernet controllers with PCI-Express interface.
  .
  This driver should only be used for devices not yet supported by the
  in-kernel driver r8169. Please see the README.Debian for instructions how

## r8168 8.039.00

=== debian/changelog ===
r8168 (8.039.00-1) unstable; urgency=medium

  * New upstream release 8.039.00 (2014-09-18).
    (Closes: #760980, #743399, #756183) (LP: #1363072)

 -- Andreas Beckmann <anbe@debian.org>  Sun, 28 Sep 2014 04:22:52 +0200

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
 Description: dkms source for the r8168 network driver
  r8168 is the Linux device driver released for RealTek RTL8111B/RTL8168B,
  RTL8111/RTL8168, RTL8111C/RTL8111CP/RTL8111D(L), RTL8168C/RTL8111DP/RTL8111E,
- RTL8168E/RTL8111F/RTL8411, RTL8111G/RTL8111GUS/RTL8411B(N)
+ RTL8168E/RTL8111F/RTL8411, RTL8111G/RTL8111GUS/RTL8411B(N), RTL8118AS
  Gigabit Ethernet controllers with PCI-Express interface.
  .
  This driver should only be used for devices not yet supported by the

## r8168 8.040.00

=== debian/changelog ===
r8168 (8.040.00-1) unstable; urgency=medium

  * New upstream release 8.040.00 (2015-05-14).
  * Move package to non-free, appears to apply binary patches to firmware.
    (Closes: #777257)
  * Bump Standards-Version to 3.9.6 (no changes needed).
  * Update Homepage and Vcs-Browser URLs.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 23 Jun 2015 12:55:20 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: r8168
-Section: kernel
+Section: non-free/kernel
 Priority: extra
 Maintainer: Andreas Beckmann <anbe@debian.org>
 Uploaders: Dmitry Smirnov <onlyjob@member.fsf.org>
 Build-Depends: debhelper (>= 9), dkms
-Standards-Version: 3.9.5
-Homepage: http://code.google.com/p/r8168/
+Standards-Version: 3.9.6
+Homepage: https://github.com/mtorromeo/r8168
 Vcs-Git: git://anonscm.debian.org/collab-maint/r8168.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/r8168.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/r8168.git
 
 Package: r8168-dkms
 Architecture: all

=== debian/watch ===
--- 
+++ 
@@ -7,4 +7,4 @@
 # ftp://user:password@ip.ip.ip.ip/path/to/r8168-(.*).tar.bz2
 
 # But there exists an unofficial mirror at http://code.google.com/p/r8168/
-http://code.google.com/p/r8168/downloads/list?can=1 .*/r8168-([\d\.]+)\.(?:tar\.gz|tar\.bz2|tar\.xz)
+http://r8168dl.appspot.com .*/r8168-([\d\.]+)\.(?:tar\.gz|tar\.bz2|tar\.xz)

## r8168 8.041.00

=== Makefile ===
################################################################################
#
# r8168 is the Linux device driver released for Realtek Gigabit Ethernet
# controllers with PCI-Express interface.
#
# Copyright(c) 2013 Realtek Semiconductor Corp. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, see <http://www.gnu.org/licenses/>.
#
# Author:
# Realtek NIC software team <nicfae@realtek.com>
# No. 2, Innovation Road II, Hsinchu Science Park, Hsinchu 300, Taiwan
#
################################################################################

################################################################################
#  This product is covered by one or more of the following patents:
#  US6,570,884, US6,115,776, and US6,327,625.
################################################################################

KFLAG := 2$(shell uname -r | sed -ne 's/^2\.[4]\..*/4/p')x

all: clean modules install

modules:
ifeq ($(KFLAG),24x)
	$(MAKE) -C src/ -f Makefile_linux24x modules
else
	$(MAKE) -C src/ modules
endif

clean:
ifeq ($(KFLAG),24x)
	$(MAKE) -C src/ -f Makefile_linux24x clean
else
	$(MAKE) -C src/ clean
endif

install:
ifeq ($(KFLAG),24x)
	$(MAKE) -C src/ -f Makefile_linux24x install
else
	$(MAKE) -C src/ install
endif

=== src/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # r8168 is the Linux device driver released for Realtek Gigabit Ethernet
 # controllers with PCI-Express interface.
 #
-# Copyright(c) 2013 Realtek Semiconductor Corp. All rights reserved.
+# Copyright(c) 2014 Realtek Semiconductor Corp. All rights reserved.
 #
 # This program is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by the Free
@@ -29,14 +29,20 @@
 #  US6,570,884, US6,115,776, and US6,327,625.
 ################################################################################
 
+ENABLE_REALWOW_SUPPORT = n
 ENABLE_DASH_SUPPORT = n
 CONFIG_DOWN_SPEED_100 = n
 CONFIG_ASPM = y
 ENABLE_S5WOL = y
+ENABLE_EEE = n
 
 ifneq ($(KERNELRELEASE),)
 	obj-m := r8168.o
 	r8168-objs := r8168_n.o r8168_asf.o rtl_eeprom.o rtltool.o
+	ifeq ($(ENABLE_REALWOW_SUPPORT), y)
+	    r8168-objs += r8168_realwow.o
+		EXTRA_CFLAGS += -DENABLE_REALWOW_SUPPORT
+	endif
 	ifeq ($(ENABLE_DASH_SUPPORT), y)
 	    r8168-objs += r8168_dash.o
 		EXTRA_CFLAGS += -DENABLE_DASH_SUPPORT
@@ -44,13 +50,16 @@
 	EXTRA_CFLAGS += -DCONFIG_R8168_NAPI
 	EXTRA_CFLAGS += -DCONFIG_R8168_VLAN
 	ifeq ($(CONFIG_DOWN_SPEED_100), y)
-		EXTRA_CFLAGS += -DCONFIG_DOWN_SPEED_100 
+		EXTRA_CFLAGS += -DCONFIG_DOWN_SPEED_100
 	endif
 	ifeq ($(CONFIG_ASPM), y)
-		EXTRA_CFLAGS += -DCONFIG_ASPM 
+		EXTRA_CFLAGS += -DCONFIG_ASPM
 	endif
 	ifeq ($(ENABLE_S5WOL), y)
-		EXTRA_CFLAGS += -DENABLE_S5WOL 
+		EXTRA_CFLAGS += -DENABLE_S5WOL
+	endif
+	ifeq ($(ENABLE_EEE), y)
+		EXTRA_CFLAGS += -DENABLE_EEE
 	endif
 else
 	BASEDIR := /lib/modules/$(shell uname -r)

=== debian/changelog ===
r8168 (8.041.00-1) unstable; urgency=medium

  [ Andreas Beckmann ]
  * New upstream release 8.041.00 (2015-12-08).  (Closes: #808124)
  * Update watch file to use the https://github.com/mtorromeo/r8168 mirror.

  [ Dmitry Smirnov ]
  * Remove myself from Uploaders.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 18 Dec 2015 14:18:32 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,6 @@
 Section: non-free/kernel
 Priority: extra
 Maintainer: Andreas Beckmann <anbe@debian.org>
-Uploaders: Dmitry Smirnov <onlyjob@member.fsf.org>
 Build-Depends: debhelper (>= 9), dkms
 Standards-Version: 3.9.6
 Homepage: https://github.com/mtorromeo/r8168

=== debian/watch ===
--- 
+++ 
@@ -6,5 +6,5 @@
 # redirects to a dynamically created ftp account like
 # ftp://user:password@ip.ip.ip.ip/path/to/r8168-(.*).tar.bz2
 
-# But there exists an unofficial mirror at http://code.google.com/p/r8168/
-http://r8168dl.appspot.com .*/r8168-([\d\.]+)\.(?:tar\.gz|tar\.bz2|tar\.xz)
+# But there exist unofficial mirrors ...
+https://github.com/mtorromeo/r8168/releases /mtorromeo/r8168/archive/([\d\.]+)\.(?:tar\.gz|tar\.bz2|tar\.xz)

## r8168 8.042.00

=== debian/changelog ===
r8168 (8.042.00-2) unstable; urgency=medium

  * linux-4.7.patch: New, from Arch Linux, fix building the module for
    Linux 4.7.  (Closes: #836961)
  * linux-2.6.32.patch: New, fix building the module for Linux 2.6.32.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 12 Sep 2016 11:09:22 +0200

r8168 (8.042.00-1) unstable; urgency=medium

  * New upstream release 8.042.00 (2016-05-12).
  * linux-4.5.patch: Remove, fixed upstream.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 28 May 2016 12:42:06 +0200

r8168 (8.041.01-1) unstable; urgency=medium

  * New upstream release 8.041.01 (2016-01-12).
  * linux-4.5.patch: New, fix building the module for Linux 4.5.
  * Bump Standards-Version to 3.9.6 (no changes needed).
  * Update Vcs-Git URL.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 08 Apr 2016 18:34:17 +0200

## r8168 8.043.02

=== src/Makefile ===
--- 
+++ 
@@ -29,16 +29,26 @@
 #  US6,570,884, US6,115,776, and US6,327,625.
 ################################################################################
 
+CONFIG_SOC_LAN = n
+ENABLE_FIBER_SUPPORT = n
 ENABLE_REALWOW_SUPPORT = n
 ENABLE_DASH_SUPPORT = n
 CONFIG_DOWN_SPEED_100 = n
 CONFIG_ASPM = y
 ENABLE_S5WOL = y
 ENABLE_EEE = n
+ENABLE_S0_MAGIC_PACKET = n
 
 ifneq ($(KERNELRELEASE),)
 	obj-m := r8168.o
 	r8168-objs := r8168_n.o r8168_asf.o rtl_eeprom.o rtltool.o
+	ifeq ($(CONFIG_SOC_LAN), y)
+		EXTRA_CFLAGS += -DCONFIG_SOC_LAN
+	endif
+	ifeq ($(ENABLE_FIBER_SUPPORT), y)
+	    r8168-objs += r8168_fiber.o
+		EXTRA_CFLAGS += -DENABLE_FIBER_SUPPORT
+	endif
 	ifeq ($(ENABLE_REALWOW_SUPPORT), y)
 	    r8168-objs += r8168_realwow.o
 		EXTRA_CFLAGS += -DENABLE_REALWOW_SUPPORT
@@ -61,11 +71,17 @@
 	ifeq ($(ENABLE_EEE), y)
 		EXTRA_CFLAGS += -DENABLE_EEE
 	endif
+	ifeq ($(ENABLE_S0_MAGIC_PACKET), y)
+		EXTRA_CFLAGS += -DENABLE_S0_MAGIC_PACKET
+	endif
 else
 	BASEDIR := /lib/modules/$(shell uname -r)
 	KERNELDIR ?= $(BASEDIR)/build
 	PWD :=$(shell pwd)
-	DRIVERDIR := $(shell find $(BASEDIR)/kernel/drivers/net -name realtek -type d)
+	DRIVERDIR := $(shell find $(BASEDIR)/kernel/drivers/net/ethernet -name realtek -type d)
+	ifeq ($(DRIVERDIR),)
+		DRIVERDIR := $(shell find $(BASEDIR)/kernel/drivers/net -name realtek -type d)
+	endif
 	ifeq ($(DRIVERDIR),)
 		DRIVERDIR := $(BASEDIR)/kernel/drivers/net
 	endif

=== debian/changelog ===
r8168 (8.043.02-1) unstable; urgency=medium

  * New upstream release 8.043.02 (2016-10-25).
  * linux-4.7.patch: Remove, fixed upstream.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 05 Nov 2016 10:35:19 +0100

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Priority: extra
 Maintainer: Andreas Beckmann <anbe@debian.org>
 Build-Depends: debhelper (>= 9), dkms
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: https://github.com/mtorromeo/r8168
-Vcs-Git: git://anonscm.debian.org/collab-maint/r8168.git
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/r8168.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/r8168.git
 
 Package: r8168-dkms

## r8168 8.044.02

=== debian/changelog ===
r8168 (8.044.02-2) unstable; urgency=medium

  * linux-4.7.patch: New, fix building the module for Linux 4.11, thanks to
    Jan Schwarzrock.  (Closes: #864867)
  * Bump Standards-Version to 4.0.0 (no changes needed).

 -- Andreas Beckmann <anbe@debian.org>  Sat, 08 Jul 2017 23:29:30 +0200

r8168 (8.044.02-1) unstable; urgency=medium

  * New upstream release 8.044.02 (2017-02-13).
  * linux-2.6.32.patch: Remove, fixed upstream.
  * Switch to debhelper compat level 10.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 21 Feb 2017 03:05:24 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: non-free/kernel
 Priority: extra
 Maintainer: Andreas Beckmann <anbe@debian.org>
-Build-Depends: debhelper (>= 9), dkms
-Standards-Version: 3.9.8
+Build-Depends: debhelper (>= 10), dkms
+Standards-Version: 4.0.0
 Homepage: https://github.com/mtorromeo/r8168
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/r8168.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/r8168.git
@@ -14,7 +14,8 @@
 Description: dkms source for the r8168 network driver
  r8168 is the Linux device driver released for RealTek RTL8111B/RTL8168B,
  RTL8111/RTL8168, RTL8111C/RTL8111CP/RTL8111D(L), RTL8168C/RTL8111DP/RTL8111E,
- RTL8168E/RTL8111F/RTL8411, RTL8111G/RTL8111GUS/RTL8411B(N), RTL8118AS
+ RTL8168E/RTL8111F/RTL8411, RTL8111G/RTL8111GUS/RTL8411B(N), RTL8118AS,
+ RTL8111H(S)/RTL8118/RTL8119i
  Gigabit Ethernet controllers with PCI-Express interface.
  .
  This driver should only be used for devices not yet supported by the

## r8168 8.045.08

=== src/Makefile ===
--- 
+++ 
@@ -33,9 +33,11 @@
 ENABLE_FIBER_SUPPORT = n
 ENABLE_REALWOW_SUPPORT = n
 ENABLE_DASH_SUPPORT = n
+ENABLE_DASH_PRINTER_SUPPORT = n
 CONFIG_DOWN_SPEED_100 = n
 CONFIG_ASPM = y
 ENABLE_S5WOL = y
+ENABLE_S5_KEEP_CURR_MAC = n
 ENABLE_EEE = n
 ENABLE_S0_MAGIC_PACKET = n
 
@@ -57,6 +59,10 @@
 	    r8168-objs += r8168_dash.o
 		EXTRA_CFLAGS += -DENABLE_DASH_SUPPORT
 	endif
+	ifeq ($(ENABLE_DASH_PRINTER_SUPPORT), y)
+	    r8168-objs += r8168_dash.o
+		EXTRA_CFLAGS += -DENABLE_DASH_SUPPORT -DENABLE_DASH_PRINTER_SUPPORT
+	endif
 	EXTRA_CFLAGS += -DCONFIG_R8168_NAPI
 	EXTRA_CFLAGS += -DCONFIG_R8168_VLAN
 	ifeq ($(CONFIG_DOWN_SPEED_100), y)
@@ -67,6 +73,9 @@
 	endif
 	ifeq ($(ENABLE_S5WOL), y)
 		EXTRA_CFLAGS += -DENABLE_S5WOL
+	endif
+	ifeq ($(ENABLE_S5_KEEP_CURR_MAC), y)
+		EXTRA_CFLAGS += -DENABLE_S5_KEEP_CURR_MAC
 	endif
 	ifeq ($(ENABLE_EEE), y)
 		EXTRA_CFLAGS += -DENABLE_EEE

=== debian/changelog ===
r8168 (8.045.08-2ubuntu1) bionic; urgency=medium

  * linux-5.3.patch: Fix build with Linux 5.3 (LP: #1852616)
  * linux-5.4.patch: Fix build with Linux 5.4 (LP: #1852616)

 -- Thadeu Lima de Souza Cascardo <cascardo@canonical.com>  Mon, 18 Nov 2019 16:11:50 -0300

r8168 (8.045.08-2) unstable; urgency=medium

  * linux-4.15-2.patch: New, from Arch Linux, fix building the module for
    Linux 4.15.  (Closes: #882838) (LP: #1737755)
  * Bump Standards-Version to 4.1.3 (no changes needed).
  * Switch to debhelper compat level 11.
  * Set Rules-Requires-Root: no.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 12 Jan 2018 00:55:37 +0100

r8168 (8.045.08-1) unstable; urgency=medium

  * New upstream release 8.045.08 (2017-09-15).  (Closes: #876085)
  * linux-4.11.patch: Remove, fixed upstream.
  * Use dpkg makefile snippets instead of manual changelog parsing.
  * Set Priority to optional.
  * Bump Standards-Version to 4.1.1.
  * Set XS-Autobuild: yes.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 04 Oct 2017 15:48:48 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,15 @@
 Source: r8168
 Section: non-free/kernel
-Priority: extra
-Maintainer: Andreas Beckmann <anbe@debian.org>
-Build-Depends: debhelper (>= 10), dkms
-Standards-Version: 4.0.0
+Priority: optional
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Andreas Beckmann <anbe@debian.org>
+Build-Depends: debhelper (>= 11~), dkms
+Rules-Requires-Root: no
+Standards-Version: 4.1.3
 Homepage: https://github.com/mtorromeo/r8168
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/r8168.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/r8168.git
+XS-Autobuild: yes
 
 Package: r8168-dkms
 Architecture: all

## r8168 8.046.00

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # r8168 is the Linux device driver released for Realtek Gigabit Ethernet
 # controllers with PCI-Express interface.
 #
-# Copyright(c) 2013 Realtek Semiconductor Corp. All rights reserved.
+# Copyright(c) 2018 Realtek Semiconductor Corp. All rights reserved.
 #
 # This program is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by the Free

=== src/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # r8168 is the Linux device driver released for Realtek Gigabit Ethernet
 # controllers with PCI-Express interface.
 #
-# Copyright(c) 2014 Realtek Semiconductor Corp. All rights reserved.
+# Copyright(c) 2018 Realtek Semiconductor Corp. All rights reserved.
 #
 # This program is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by the Free

=== debian/changelog ===
r8168 (8.046.00-1) unstable; urgency=medium

  * New upstream release 8.046.00 (2018-08-03).  (Closes: #903255)
  * Remove kernel support patches that were fixed upstream.
  * Refresh remaining patches.
  * Bump Standards-Version to 4.2.0 (no changes needed).
  * Use the real upstream as Homepage, not the unofficial mirror.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 09 Aug 2018 15:54:32 +0200

r8168 (8.045.08-3) unstable; urgency=medium

  * Restore support for older kernels.
  * Switch Vcs-* URLs to salsa.debian.org.
  * Bump Standards-Version to 4.1.4 (no changes needed).

 -- Andreas Beckmann <anbe@debian.org>  Fri, 06 Apr 2018 14:42:03 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,13 @@
 Source: r8168
 Section: non-free/kernel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Andreas Beckmann <anbe@debian.org>
+Maintainer: Andreas Beckmann <anbe@debian.org>
 Build-Depends: debhelper (>= 11~), dkms
 Rules-Requires-Root: no
-Standards-Version: 4.1.3
-Homepage: https://github.com/mtorromeo/r8168
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/r8168.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/r8168.git
+Standards-Version: 4.2.0
+Homepage: http://www.realtek.com.tw/downloads/downloadsView.aspx?PFid=5&Level=5&Conn=4&DownTypeID=3#2
+Vcs-Browser: https://salsa.debian.org/debian/r8168
+Vcs-Git: https://salsa.debian.org/debian/r8168.git
 XS-Autobuild: yes
 
 Package: r8168-dkms

## r8168 8.047.01

=== debian/changelog ===
r8168 (8.047.01-1) unstable; urgency=medium

  * New upstream release 8.047.01 (2019-04-18).
  * Switch to debhelper-compat (= 12).
  * Update Homepage URL.
  * Bump Standards-Version to 4.3.0 (no changes needed).

 -- Andreas Beckmann <anbe@debian.org>  Sat, 27 Apr 2019 06:56:01 +0200

=== debian/control ===
Source: r8168
Section: non-free/kernel
Priority: optional
Maintainer: Andreas Beckmann <anbe@debian.org>
Build-Depends:
 debhelper-compat (= 12),
 dkms,
Rules-Requires-Root: no
Standards-Version: 4.3.0
Homepage: https://www.realtek.com/en/component/zoo/category/network-interface-controllers-10-100-1000m-gigabit-ethernet-pci-express-software
Vcs-Browser: https://salsa.debian.org/debian/r8168
Vcs-Git: https://salsa.debian.org/debian/r8168.git
XS-Autobuild: yes

Package: r8168-dkms
Architecture: all
Depends: ${misc:Depends}
Description: dkms source for the r8168 network driver
 r8168 is the Linux device driver released by RealTek for their network
 controllers with PCI-Express interface:
  * 2.5G Gigabit Ethernet: RTL8125
  * 10/100/1000M Gigabit Ethernet: RTL8111B, RTL8111C, RTL8111D, RTL8111E,
    RTL8111F, RTL8111G(S), RTL8111H(S), RTL8118(A)(S), RTL8119i, RTL8111L,
    RTL8168B, RTL8168E, RTL8168H, RTL8111DP, RTL8111EP, RTL8111FP, RTL8411,
    RTL8411B
  * 10/100M Fast Ethernet: RTL8101E, RTL8102E, RTL8103E, RTL8105E, RTL8106E,
    RTL8107E, RTL8401, RTL8402
 .
 This driver should only be used for devices not yet supported by the
 in-kernel driver r8169. Please see the README.Debian for instructions how
 to report bugs against r8169 that made it necessary to use r8168-dkms.
 .
 Installation of the r8168-dkms package will disable the in-kernel r8169
 module. To re-enable r8169, the r8168-dkms package must be purged.
 .
 This package provides the dkms source code for the r8168 kernel modules.
 Kernel source or headers are required to compile these modules.

## r8168 8.047.02

=== src/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # r8168 is the Linux device driver released for Realtek Gigabit Ethernet
 # controllers with PCI-Express interface.
 #
-# Copyright(c) 2018 Realtek Semiconductor Corp. All rights reserved.
+# Copyright(c) 2019 Realtek Semiconductor Corp. All rights reserved.
 #
 # This program is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by the Free
@@ -96,20 +96,66 @@
 	endif
 	RTKDIR := $(subst $(BASEDIR)/,,$(DRIVERDIR))
 
+	KERNEL_GCC_VERSION := $(shell cat /proc/version | sed -n 's/.*gcc version \([[:digit:]]\.[[:digit:]]\.[[:digit:]]\).*/\1/p')
+	CCVERSION = $(shell $(CC) -dumpversion)
+
+	KVER = $(shell uname -r)
+	KMAJ = $(shell echo $(KVER) | \
+	sed -e 's/^\([0-9][0-9]*\)\.[0-9][0-9]*\.[0-9][0-9]*.*/\1/')
+	KMIN = $(shell echo $(KVER) | \
+	sed -e 's/^[0-9][0-9]*\.\([0-9][0-9]*\)\.[0-9][0-9]*.*/\1/')
+	KREV = $(shell echo $(KVER) | \
+	sed -e 's/^[0-9][0-9]*\.[0-9][0-9]*\.\([0-9][0-9]*\).*/\1/')
+
+	kver_ge = $(shell \
+	echo test | awk '{if($(KMAJ) < $(1)) {print 0} else { \
+	if($(KMAJ) > $(1)) {print 1} else { \
+	if($(KMIN) < $(2)) {print 0} else { \
+	if($(KMIN) > $(2)) {print 1} else { \
+	if($(KREV) < $(3)) {print 0} else { print 1 } \
+	}}}}}' \
+	)
+
 .PHONY: all
-all: clean modules install
+all: print_vars clean modules install
+
+print_vars:
+	@echo
+	@echo "CC: " $(CC)
+	@echo "CCVERSION: " $(CCVERSION)
+	@echo "KERNEL_GCC_VERSION: " $(KERNEL_GCC_VERSION)
+	@echo "KVER: " $(KVER)
+	@echo "KMAJ: " $(KMAJ)
+	@echo "KMIN: " $(KMIN)
+	@echo "KREV: " $(KREV)
+	@echo "BASEDIR: " $(BASEDIR)
+	@echo "DRIVERDIR: " $(DRIVERDIR)
+	@echo "PWD: " $(PWD)
+	@echo "RTKDIR: " $(RTKDIR)
+	@echo
 
 .PHONY:modules
 modules:
-	$(MAKE) -C $(KERNELDIR) SUBDIRS=$(PWD) modules
+#ifeq ($(call kver_ge,5,0,0),1)
+	$(MAKE) -C $(KERNELDIR) M=$(PWD) modules
+#else
+#	$(MAKE) -C $(KERNELDIR) SUBDIRS=$(PWD) modules
+#endif
 
 .PHONY:clean
 clean:
-	$(MAKE) -C $(KERNELDIR) SUBDIRS=$(PWD) clean
+#ifeq ($(call kver_ge,5,0,0),1)
+	$(MAKE) -C $(KERNELDIR) M=$(PWD) clean
+#else
+#	$(MAKE) -C $(KERNELDIR) SUBDIRS=$(PWD) clean
+#endif
 
 .PHONY:install
 install:
-	$(MAKE) -C $(KERNELDIR) SUBDIRS=$(PWD) INSTALL_MOD_DIR=$(RTKDIR) modules_install
+#ifeq ($(call kver_ge,5,0,0),1)
+	$(MAKE) -C $(KERNELDIR) M=$(PWD) INSTALL_MOD_DIR=$(RTKDIR) modules_install
+#else
+#	$(MAKE) -C $(KERNELDIR) SUBDIRS=$(PWD) INSTALL_MOD_DIR=$(RTKDIR) modules_install
+#endif
 
 endif
-

=== debian/changelog ===
r8168 (8.047.02-1) unstable; urgency=medium

  * New upstream release 8.047.02 (2019-06-21).
  * Refresh patches.
  * Bump Standards-Version to 4.4.0 (no changes needed).

 -- Andreas Beckmann <anbe@debian.org>  Tue, 30 Jul 2019 12:38:20 +0200

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  debhelper-compat (= 12),
  dkms,
 Rules-Requires-Root: no
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Homepage: https://www.realtek.com/en/component/zoo/category/network-interface-controllers-10-100-1000m-gigabit-ethernet-pci-express-software
 Vcs-Browser: https://salsa.debian.org/debian/r8168
 Vcs-Git: https://salsa.debian.org/debian/r8168.git
@@ -18,13 +18,10 @@
 Description: dkms source for the r8168 network driver
  r8168 is the Linux device driver released by RealTek for their network
  controllers with PCI-Express interface:
-  * 2.5G Gigabit Ethernet: RTL8125
   * 10/100/1000M Gigabit Ethernet: RTL8111B, RTL8111C, RTL8111D, RTL8111E,
     RTL8111F, RTL8111G(S), RTL8111H(S), RTL8118(A)(S), RTL8119i, RTL8111L,
     RTL8168B, RTL8168E, RTL8168H, RTL8111DP, RTL8111EP, RTL8111FP, RTL8411,
     RTL8411B
-  * 10/100M Fast Ethernet: RTL8101E, RTL8102E, RTL8103E, RTL8105E, RTL8106E,
-    RTL8107E, RTL8401, RTL8402
  .
  This driver should only be used for devices not yet supported by the
  in-kernel driver r8169. Please see the README.Debian for instructions how

## r8168 8.048.00

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # r8168 is the Linux device driver released for Realtek Gigabit Ethernet
 # controllers with PCI-Express interface.
 #
-# Copyright(c) 2018 Realtek Semiconductor Corp. All rights reserved.
+# Copyright(c) 2019 Realtek Semiconductor Corp. All rights reserved.
 #
 # This program is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by the Free
@@ -53,6 +53,3 @@
 else
 	$(MAKE) -C src/ install
 endif
-
-
-

=== debian/changelog ===
r8168 (8.048.00-1ubuntu0.20.04.2) focal; urgency=medium

  * No change rebuild in security pocket. LP: #1914279.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 29 Apr 2021 16:08:42 +0100

r8168 (8.048.00-1ubuntu0.20.04.1) focal; urgency=medium

  * Fix build for kernel version 5.6+ (LP: #1892089)
    - debian/patches/linux-5.6.patch (cherry picked from 8.048.02-1)

 -- Stefan Bader <stefan.bader@canonical.com>  Tue, 27 Oct 2020 14:57:56 +0100

r8168 (8.048.00-1) unstable; urgency=medium

  * New upstream release 8.048.00 (2020-01-08).

 -- Andreas Beckmann <anbe@debian.org>  Wed, 15 Jan 2020 01:18:32 +0100

r8168 (8.047.05-1) unstable; urgency=medium

  * New upstream release 8.047.05 (2019-11-15).
  * linux-5.4.patch: New, from Ubuntu, fix building the module for Linux 5.4.
    (LP: #1852616)

 -- Andreas Beckmann <anbe@debian.org>  Fri, 22 Nov 2019 13:56:10 +0100

r8168 (8.047.04-1) unstable; urgency=medium

  * New upstream release 8.047.04 (2019-08-02).
  * linux-3.5.patch: New, add fallback for some macros that may be undefined.
  * Bump Standards-Version to 4.4.1 (no changes needed).

 -- Andreas Beckmann <anbe@debian.org>  Tue, 22 Oct 2019 11:05:32 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: r8168
 Section: non-free/kernel
 Priority: optional
-Maintainer: Andreas Beckmann <anbe@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Andreas Beckmann <anbe@debian.org>
 Build-Depends:
  debhelper-compat (= 12),
  dkms,
 Rules-Requires-Root: no
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Homepage: https://www.realtek.com/en/component/zoo/category/network-interface-controllers-10-100-1000m-gigabit-ethernet-pci-express-software
 Vcs-Browser: https://salsa.debian.org/debian/r8168
 Vcs-Git: https://salsa.debian.org/debian/r8168.git

## r8168 8.048.03

=== src/Makefile ===
--- 
+++ 
@@ -38,7 +38,7 @@
 CONFIG_ASPM = y
 ENABLE_S5WOL = y
 ENABLE_S5_KEEP_CURR_MAC = n
-ENABLE_EEE = n
+ENABLE_EEE = y
 ENABLE_S0_MAGIC_PACKET = n
 
 ifneq ($(KERNELRELEASE),)

=== debian/changelog ===
r8168 (8.048.03-3) unstable; urgency=medium

  * Switch to dh-sequence-dkms.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 15 Feb 2021 16:08:14 +0100

r8168 (8.048.03-2) unstable; urgency=medium

  * d/watch: Parse only the version number from the upstream download page.
  * Bump Standards-Version to 4.5.1 (no changes needed).

 -- Andreas Beckmann <anbe@debian.org>  Thu, 07 Jan 2021 13:46:24 +0100

r8168 (8.048.03-1) unstable; urgency=medium

  * New upstream release 8.048.03 (2020-05-25).
  * Refresh patches.
  * Switch to debhelper-compat (= 13).
  * Use Testsuite: autopkgtest-pkg-dkms.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 04 Jun 2020 09:42:24 +0200

r8168 (8.048.02-1) unstable; urgency=medium

  * New upstream release 8.048.02 (2020-03-19).
  * Bump Standards-Version to 4.5.0 (no changes needed).
  * linux-5.6.patch: New, adapt to Linux 5.6 changes.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 30 Apr 2020 00:06:23 +0200

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,17 @@
 Source: r8168
 Section: non-free/kernel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Andreas Beckmann <anbe@debian.org>
+Maintainer: Andreas Beckmann <anbe@debian.org>
 Build-Depends:
- debhelper-compat (= 12),
- dkms,
+ debhelper-compat (= 13),
+ dh-sequence-dkms,
 Rules-Requires-Root: no
-Standards-Version: 4.4.1
+Standards-Version: 4.5.1
 Homepage: https://www.realtek.com/en/component/zoo/category/network-interface-controllers-10-100-1000m-gigabit-ethernet-pci-express-software
 Vcs-Browser: https://salsa.debian.org/debian/r8168
 Vcs-Git: https://salsa.debian.org/debian/r8168.git
 XS-Autobuild: yes
+Testsuite: autopkgtest-pkg-dkms
 
 Package: r8168-dkms
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

%:
	dh $@

override_dh_install:
	dh_install src/*.h src/*.c src/Makefile usr/src/r8168-$(DEB_VERSION_UPSTREAM)/
	find debian/r8168-dkms/usr/src -type f -perm -5 -print0 2>/dev/null | xargs -0r chmod a-X

override_dh_dkms:
	dh_dkms -V $(DEB_VERSION_UPSTREAM)

# do nothing
override_dh_auto_configure override_dh_auto_build override_dh_auto_test override_dh_auto_install override_dh_auto_clean:
